;Adobe Helvetica normal
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;%include "./INC/SCHLEIFE.inc"

;buf			resb	25
;schleifdat		dd	0		;Dateinummer zur Speicherung der Schleifen
;nameschleifdat	db	's.tmp',0

;-------------------------------------------------
SCHLEIFE:
section .data

.anz			dd	0

section .text

	mov	eax,3
	mov	ebx,[datnum]
	mov	ecx,buf
	mov	edx,9
	int	80h				;lese 9 Bytes ein
	cmp	eax,9
	jz	.a
	call	error1
	jmp	Ende
.a:
	sub	dword[buf],1		;dekrementiere anzahl
	jc	.a5
	jmp	.b
;--------------------------------------- Schleife ausgelaufen - erneuern und naechster Befehl
.a5:
	mov	eax,19			;setze den Dateizeiger
	mov	ebx,[datnum]		;von nc.tmp
	mov	ecx,10			;10 Bytes
	add	ecx,[buf+4]			;+ SCHLEIFE Bytes zurueck
	mov	[.anz],ecx
	neg	ecx				;niedriger
	mov	edx,1				;von der aktuellen Position (Befehl nach Schleife)
	int	80h
	cmp	eax,0
	jns	.a6
	call	error1
	jmp	Ende
.a6:
	mov	ecx,eax			;Position von nc.tmp
	mov	eax,19			;setze den Dateizeiger
	mov	ebx,[schleifdat]		;von s.tmp
	mov	edx,0				;vom Anfang
	int	80h
	cmp	eax,0				;eax = atuelle Position
	jns	.a7
	call	error1
	jmp	Ende
.a7:
	mov	eax,3				;lese
	mov	ebx,[schleifdat]		;von s.tmp
	mov	ecx,buf
	add	ecx,9				;nach buf+9
	mov	edx,1				;1 Byte 
	int	80h				;ein
	cmp	eax,1
	jz	.a8
	call	error1
	jmp	Ende
.a8:
	mov	eax,4				;schreibe
	mov	ebx,[datnum]		;in nc.tmp
	mov	ecx,buf
	add	ecx,9				;von buf+9
	mov	edx,1				;1 Bytes
	int	80h
	cmp	eax,1
	jz	.a9
	call	error1
	jmp	Ende
.a9:
	dec	dword[.anz]
	jnz	.a7
	
	mov	al,[buf+8]			;naechster Befehl in al
	ret

;--------------------------------------- Zurueck zum Schleifenanfang
.b:
	mov	eax,19			;setze den Dateizeiger
	mov	ebx,[datnum]		;von nc.tmp
	mov	ecx,9				;9 Bytes
	neg	ecx				;niedriger
	mov	edx,1
	int	80h
	cmp	eax,0
	jns	.b6
	call	error1
	jmp	Ende
.b6:
	mov	eax,4				;schreibe
	mov	ebx,[datnum]		;in nc.tmp
	mov	ecx,buf			;von buf
	mov	edx,4				;4 Bytes
	int	80h
	cmp	eax,4
	jz	.b10
	call	error1
	jmp	Ende
.b10:
	mov	eax,19			;setze den Dateizeiger
	mov	ebx,[datnum]		;von nc.tmp
	mov	ecx,[buf+4]			;SCHLEIFE Bytes
	add	ecx,5				;und 5 (Befehl 9 davon 4 geschrieben)
	neg	ecx				;niedriger
	mov	edx,1				;from curend position
	int	80h
	cmp	eax,0
	jns	.b15
	call	error1
	jmp	Ende
.b15:
	mov	eax,3				;lese
	mov	ebx,[datnum]		;von nc.tmp
	mov	ecx,buf			;in buf
	mov	edx,1				;1 byte
	int	80h
	cmp	eax,1
	jz	.b20
	call	error1
	jmp	Ende
.b20:
	mov	al,[buf]
	ret


