;Adobe Helvetica normal
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;%include "./INC/SCHLEIFENSATZ.inc"

;buf			resb	25
;-------------------------------------------------
SCHLEIFENSATZ:
section .data

.zaehler			dd	0,0
.funktion			db	0

section .text

	mov	eax,3				;lese
	mov	ebx,[datnum]		;von nc.tmp
	mov	ecx,buf			;nach
	mov	edx,5
	int	80h				;lese 5 Bytes ein
	cmp	eax,5
	jz	.a
	call	error1
	jmp	Ende
.a:
	mov	eax,19			;setze den Dateizeiger
	mov	ebx,[datnum]		;von nc.tmp
	mov	ecx,[buf]			;"Bytes vor" (bis vor die Schleife)
	mov	edx,1				;von der aktuellen Position
	int	80h
	cmp	eax,0
	jns	.a1
	call	error1
	jmp	Ende
.a1:
	mov	eax,3				;lese
	mov	ebx,[datnum]		;von nc.tmp
	mov	ecx,.zaehler		;nach .zaehler
	mov	edx,4				;4 Bytes
	int	80h				;ein
	cmp	eax,4				;4 gelesen?
	jz	.a2
	call	error1
	jmp	Ende
.a2:
	cmp	dword[.zaehler],0		;Schleife ausgelaufen?
	jnz	.b1				;nein ->
;-------------------------------------- Schleife ausgelaufen
	mov	eax,19			;setze den Dateizeiger
	mov	ebx,[datnum]		;von nc.tmp
	mov	ecx,4				;4 Bytes
	neg	ecx				;zurueck
	mov	edx,1				;von der aktuellen Position
	int	80h
	cmp	eax,0
	jns	.a3
	call	error1
	jmp	Ende
.a3:
	mov	al,12				;Befehl "}SCHLEIFE"
	ret
;-------------------------------------- Schleife nicht ausgelaufen
.b1:
	mov	eax,19			;setze den Dateizeiger
	mov	ebx,[datnum]		;von nc.tmp
	mov	ecx,4				;4 Bytes
	add	ecx,[buf]			;+ "Bytes vor"
	neg	ecx				;zurueck
	mov	edx,1				;von der aktuellen Position
	int	80h
	cmp	eax,0
	jns	.b2
	call	error1
	jmp	Ende
.b2:
	mov	al,[buf+4]
	ret


