;Adobe Helvetica normal
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;Gibt den Wert von eax als Dezimalzahl auf der Standardausgabe aus.
;-------------------------------------------------

;%include "./INC/error1.inc"

error1:
section .data

.fehler1	db	'  Operation nicht erlaubt',10,\
			'(Versuchen Sie es als root )',10,0
.fehler1l	equ	$-.fehler1
.fehler2	db	'   Datei oder Verzeichnis nicht gefunden ! ',10,0
.fehler2l	equ	$-.fehler2
.fehler3	db	'   Prozess nicht gefunden ! ',10,0
.fehler3l	equ	$-.fehler3
.fehler4	db	'   Systemaufruf wurde unterbrochen ! ',10,0
.fehler4l	equ	$-.fehler4
.fehler5	db	'   I/O Fehler ! ',10,0
.fehler5l	equ	$-.fehler5
.fehler6	db	'   Geraet oder Adresse nicht gefunden ! ',10,0
.fehler6l	equ	$-.fehler6
.fehler7	db	'   Argumentenliste ist zu lang ! ',10,0
.fehler7l	equ	$-.fehler7
.fehler8	db	'   Format nicht ausfuehrbar ! ',10,0
.fehler8l	equ	$-.fehler8
.fehler9	db	'   Falsche Dateinummer ! ',10,0
.fehler9l	equ	$-.fehler9
.fehler10	db	'   Kein Kindsprozess ! ',10,0
.fehler10l	equ	$-.fehler10
.fehler11	db	'   Versuchen Sie es nochmal ! ',10,0
.fehler11l	equ	$-.fehler11
.fehler12	db	'   Speicherzugriffsfehler ! ',10,0
.fehler12l	equ	$-.fehler12
.fehler13	db	'   Erlaubnis bentigt ! ',10,0
.fehler13l	equ	$-.fehler13
.fehler14	db	'   Fehlerhafte Adresse ! ',10,0
.fehler14l	equ	$-.fehler14
.fehler15	db	'   benoetigt Blockorientiertes Geraet ! ',10,0
.fehler15l	equ	$-.fehler15
.fehler16	db	'   Gert oder Treiber beschaeftigt ! ',10,0
.fehler16l	equ	$-.fehler16
.fehler17	db	'   Datei vorhanden ! ',10,0
.fehler17l	equ	$-.fehler17
.fehler18	db	'   Cross-device link ! ',10,0
.fehler18l	equ	$-.fehler18
.fehler19	db	'   Geraet ist nicht vorhanden ! ',10,0
.fehler19l	equ	$-.fehler19
.fehler20	db	'   Das ist kein Verzeichnis ! ',10,0
.fehler20l	equ	$-.fehler20
.fehler21	db	'   Das ist ein Verzeichnis ! ',10,0
.fehler21l	equ	$-.fehler21
.fehler22	db	'   Fehlerhaftes Argument ! ',10,0
.fehler22l	equ	$-.fehler22
.fehler23	db	'   Dateitabellen-Ueberlauf ! ',10,0
.fehler23l	equ	$-.fehler23
.fehler24	db	'   Zu viel geoeffnete Dateien ! ',10,0
.fehler24l	equ	$-.fehler24
.fehler25	db	'   Kein zeichenorientiertes Geraet ! ',10,0
.fehler25l	equ	$-.fehler25
.fehler26	db	'   Textdatei ist beschaeftigt ! ',10,0
.fehler26l	equ	$-.fehler26
.fehler27	db	'   Datei ist zu gross ! ',10,0
.fehler27l	equ	$-.fehler27
.fehler28	db	'   Kein Platz mehr auf dem Ziel ! ',10,0
.fehler28l	equ	$-.fehler28
.fehler29	db	'   Fehlerhafter Dateizeiger ! ',10,0
.fehler29l	equ	$-.fehler29
.fehler30	db	'   Dateisystem darf nur gelesen werden ! ',10,0
.fehler30l	equ	$-.fehler30
.fehler31	db	'   Zu viele Verweise ! ',10,0
.fehler31l	equ	$-.fehler31


.fehlerx	db	'   Ein unbekannter Fehler ist Aufgetreten : ',10,0
.fehlerxl	equ	$-.fehlerx

.save		dd	0

section .text
	pushad
	neg	eax
	mov	[.save],eax

	cmp eax,1
	jnz .f1
	mov ecx,.fehler1
	mov edx,.fehler1l
	jmp .ende
.f1:
	cmp eax,2
	jnz .f2
	mov ecx,.fehler2
	mov edx,.fehler2l
	jmp .ende
.f2:
	cmp eax,3
	jnz .f3
	mov ecx,.fehler3
	mov edx,.fehler3l
	jmp .ende
.f3:
	cmp eax,4
	jnz .f4
	mov ecx,.fehler4
	mov edx,.fehler4l
	jmp .ende
.f4:
	cmp eax,2
	jnz .f5
	mov ecx,.fehler5
	mov edx,.fehler5l
	jmp .ende
.f5:
	cmp eax,6
	jnz .f6
	mov ecx,.fehler6
	mov edx,.fehler6l
	jmp .ende
.f6:
	cmp eax,7
	jnz .f7
	mov ecx,.fehler7
	mov edx,.fehler7l
	jmp .ende
.f7:
	cmp eax,8
	jnz .f8
	mov ecx,.fehler8
	mov edx,.fehler8l
	jmp .ende
.f8:
	cmp eax,9
	jnz .f9
	mov ecx,.fehler9
	mov edx,.fehler9l
	jmp .ende
.f9:
	cmp eax,10
	jnz .f10
	mov ecx,.fehler10
	mov edx,.fehler10l
	jmp .ende
.f10:
	cmp eax,11
	jnz .f11
	mov ecx,.fehler11
	mov edx,.fehler11l
	jmp .ende
.f11:
	mov ecx,.fehlerx
	mov edx,.fehlerxl
	
.ende:	
	mov	eax,4
	mov	ebx,1
	int	$80
	mov	eax,[.save]
	call	error

.ende1:
	popad
	ret
