;Adobe Helvetica normal
;-------------------------------------------------
;	Code for the best assembler: The Netwide Assembler: NASM
;	Copyright (C) 2004 by Sebastian Beck; sebastian.bw@freenet.de

;	Wenn Sie eine Spende machen wollen, fragen Sie mich ber E-Mail
;	nach meiner Bankverbindung.

;	If you want to make a donation, please question me by e-mail for
;	my banking connection.

;-------------------------------------------------
;Springt angegebene Bytes vor (+) oder zurueck (-) beim druecken der Taste [J]. Siehe SPRINGE.
;Alle anderen Tasten bedeuten normal weiter.
;-------------------------------------------------
;%include "./INC/FRAGE.inc"

;section .bss
;buf			resb	25
;buf1			resb	28
;buf2			resb	28
;-------------------------------------------------
FRAGE:
section .data

.return		db	10

section .text
	mov	eax,3				;lese
	mov	ebx,[datnum]		;von datei
	mov	ecx,buf			;nach buffer
	mov	edx,6				;Bytes ein
	int	80h
	cmp	eax,6				;alle Bytes gelesen?
	jz	.a
	call	error1
	jmp	Ende
;-------------------------------------------------Frage ausgeben
.a:
	mov	eax,3				;lese
	mov	ebx,[datnum]		;von datei
	mov	ecx,buf+6			;nach buffer
	mov	edx,1				;Bytes ein
	int	80h
	cmp	eax,1				;alle Bytes gelesen?
	jz	.a1
	call	error1
	jmp	Ende
.a1:
	mov	eax,4				;schreibe
	mov	ebx,1				;auf Terminal 
	mov	ecx,buf+6			;von Adresse
	mov	edx,1				;Bytes
	int	$80
	dec	word[buf+4]
	jnz	.a
	
	mov	eax,4				;schreibe
	mov	ebx,1				;auf Terminal 
	mov	ecx,.return			;von Adresse
	mov	edx,1				;Bytes
	int	$80
	
;-------------------------------------------------Terminal Attribute herstellen
	mov	ecx,7				;7 dwords
	mov	ebx,buf1			;von	.buf1
	mov	eax,0				;mit 0
.a2:
	mov	[ebx],eax			;loeschen
	add	ebx,4
	loop	.a2

	mov	eax,54
	mov	ebx,0
	mov	ecx,0x5401		;get terminal attributes
	mov	edx,buf1
	int	80h
	cmp	eax,0
	jz	.a5
	call	error
	jmp	Ende
.a5:
	mov	ebx,buf1
	mov	ebp,buf2
	mov	ecx,7
.a6:
	mov	eax,[ebx]			;Kopiere buf1 -> buf2
	add	ebx,4
	mov	[ebp],eax
	add	ebp,4
	loop	.a6
	
	and	dword[buf1+12],11111111111111111111111111110101b
	or	dword[buf1+12],00000000000000000100000000000000b
;	or	byte[buf1+17],00100000b
	and	byte[buf1+17],11011111b

	mov	eax,54
	mov	ebx,0
	mov	ecx,0x5402		;set terminal attributes
	mov	edx,buf1
	int	80h
	cmp	eax,0
	jz	.b
	call	error
	jmp	Ende
	
;-------------------------------------------------Auf Eingabe warten
.b:
	mov	eax,3				;lese
	mov	ebx,0				;von Terminal
	mov	ecx,buf+6			;nach
	mov	edx,1				;Bytes
	int	80h				;ein
	cmp	eax,1				;ob Bytes gelesen
	jz	.b1
	call	error1
	jmp	Ende
.b1:
	cmp	byte[buf+6],106		;ist = J ?
	jnz	.b3				;nein -> b3
	
	mov	eax,19			;setze den Dateizeiger
	mov	ebx,[datnum]		;von nc.tmp
	mov	ecx,[buf]			;Anzahl Bytes
	mov	edx,0				;von Datei Anfang
	int	80h
	jnc	.b3
	call	error1
	jmp	Ende
.b3:
	mov	eax,3				;lese
	mov	ebx,[datnum]		;von datei
	mov	ecx,buf			;nach buffer
	mov	edx,1				;Bytes ein
	int	80h
	cmp	eax,1				;alle Bytes gelesen?
	jz	.b4
	call	error1
	jmp	Ende
.b4:
	mov	eax,54			;Restore terminal attributes
	mov	ebx,0
	mov	ecx,0x5402		;set terminal attributes
	mov	edx,buf2
	int	80h
	cmp	eax,0
	jz	.ende
	call	error
	jmp	Ende
	
.ende:
	mov	al,[buf]			;naechster Befehl in al
	ret


